var FenrirCreateImagePopup = function( img, hoverElem, orgLink) {

	var linkPopup;
	var bigimg;
	var ImgDiv;

	if ( img.hasClass( "fenrir_ih_set" ) ) {
		return;
	}

	img.addClass( "fenrir_ih_set" );

	linkPopup = $('<a>', {target: '_blank'});
	ImgDiv = $('<div>');
	ImgDiv.append( linkPopup );
	ImgDiv.css('display', 'none');
	ImgDiv.css('size', 'auto');
	ImgDiv.addClass( "fenrir_img_div" );
	$(document.body).append( ImgDiv );

	bigimg = $('<img>');
	linkPopup.append( bigimg );

	bigimg.bind( 'error', function(){
		$(this).remove();
		ImgDiv.css('display', 'none');
	});

	linkPopup.attr( 'href', orgLink );
	bigimg.attr( 'src', orgLink );

	var Img_Hover = 0;
	var ImgDiv_Hover = 0;

	var CheckImageHover = function () {
		if (( Img_Hover == 0 ) && (ImgDiv_Hover == 0)) {
			ImgDiv.css( 'display', 'none');
			ImgDiv.css( 'z-index', '1');
		} else{
			setTimeout( CheckImageHover, 50 );
		}
	}

	var CallCheckImageHover = function () {
		setTimeout( CheckImageHover, 50 );
	}

	ImgDiv.hover(
		function () {
			ImgDiv_Hover = 1;
		},
		function () {
			ImgDiv_Hover = 0;
			CallCheckImageHover();
		}
	);

	img.hover(
		function (event) {
			var imgElem = img.get(0);
			if (( imgElem.width == imgElem.naturalWidth ) && ( imgElem.height == imgElem.naturalHeight ) ) {
				if ( imgElem.src == orgLink) {
					return;
				}
			}

			Img_Hover = 1;

			ImgDiv.css( 'position', 'absolute');
			ImgDiv.css( 'display', 'block');
			ImgDiv.css( 'z-index', '999999999');

			bigimg.css('max-width', 800);
			bigimg.css('max-height', 800);

			org_width = bigimg.width();
			org_height = bigimg.height();

			var div_left = hoverElem.offset().left;
			var div_top = hoverElem.offset().top;
			var div_width = img.width();
			var div_height = img.height();

			var bx = 0, by = 0;

			var cw = $(window).width();
			var ch = $(window).height();

			var sl = $(document.body).scrollLeft();
			var st = $(document.body).scrollTop();

			bx = sl + event.clientX - event.offsetX + div_width + 20;
			by = st + event.clientY - event.offsetY;

			var diff;

			diff = (bx + org_width) - ( sl + cw);
			var bx_back = bx
			if (diff > 0) {
				bx  = bx - (org_width + div_width + 40);
				if (bx < 0) {
					bx = bx_back;
				}
			}

			diff = (by + org_height) - ( st + ch);
			if (diff > 0) {
				by  = by - diff;
			}

			ImgDiv.css('left', bx);
			ImgDiv.css('top', by);

			return false;
		},
		function () {
			Img_Hover = 0;
			CallCheckImageHover();
			return false;
		}
	);
}
